#define DIRECTINPUT_VERSION 0x0800
#define DEFINE_RAW_INPUT
#include <windows.h>
#include <dinput.h>
#include <stdio.h>
#define WM_INPUT            0x00FF
#define MOUSE_INPUT         0xABC123

#ifdef DEBUG_RAW_INPUT
FILE *debug_file;
#endif

BOOL                   mouse_init = FALSE;
LPDIRECTINPUT8         lpdi;
LPDIRECTINPUTDEVICE8   m_mouse;

UINT WINAPI XP_GetRawInputData(HRAWINPUT hRawInput, UINT uiCommand, LPVOID pData, PUINT pcbSize, UINT cbSizeHeader) {
	static DIMOUSESTATE2 mouse_state;
	static DIMOUSESTATE2 mouse_state_prev;
	HRESULT hr;
	RAWINPUT *raw;
	int i;
	
	if(!mouse_init) return FALSE;
	
	if(pData == NULL) {
		*pcbSize = sizeof(RAWINPUT); //You need the whole fucking thing beotch
		return 0;
	}
	
	raw = pData;
	raw->header.dwType = RIM_TYPEMOUSE;
	raw->header.dwSize = sizeof(RAWINPUT);
	raw->header.hDevice = NULL;
	raw->header.wParam = RIM_INPUT;
	
	//Try to get input, and maybe reaquire input
	hr = m_mouse->lpVtbl->GetDeviceState(m_mouse, sizeof(DIMOUSESTATE2), (LPVOID)&mouse_state);
	if(FAILED(hr)) {
		m_mouse->lpVtbl->Acquire(m_mouse);
		while(hr == DIERR_INPUTLOST) {
			hr = m_mouse->lpVtbl->Acquire(m_mouse);
		}
		if(FAILED(hr)) return -1;
		m_mouse->lpVtbl->GetDeviceState(m_mouse, sizeof(DIMOUSESTATE2), (LPVOID)&mouse_state);
	}
	
	raw->data.mouse.usFlags = MOUSE_MOVE_RELATIVE;
	raw->data.mouse.lLastX = mouse_state.lX;
	raw->data.mouse.lLastY = mouse_state.lY;
	raw->data.mouse.usButtonData = (short)mouse_state.lZ;
	raw->data.mouse.usButtonFlags = RI_MOUSE_WHEEL;
	raw->data.mouse.ulRawButtons = 0;
	
	for(i = 0; i < 8; i++) {
		if(mouse_state.rgbButtons[i] & 0x80) {
			raw->data.mouse.ulRawButtons |= 1<<i;
		}
	}
	
	if(mouse_state.rgbButtons[0] & 0x80 && !(mouse_state_prev.rgbButtons[0] & 0x80))
		raw->data.mouse.usButtonFlags |= RI_MOUSE_LEFT_BUTTON_DOWN;
	
	if(!(mouse_state.rgbButtons[0] & 0x80) && mouse_state_prev.rgbButtons[0] & 0x80)
		raw->data.mouse.usButtonFlags |= RI_MOUSE_LEFT_BUTTON_UP;
		
	if(mouse_state.rgbButtons[1] & 0x80 && !(mouse_state_prev.rgbButtons[1] & 0x80))
		raw->data.mouse.usButtonFlags |= RI_MOUSE_RIGHT_BUTTON_DOWN;
	
	if(!(mouse_state.rgbButtons[1] & 0x80) && mouse_state_prev.rgbButtons[1] & 0x80)
		raw->data.mouse.usButtonFlags |= RI_MOUSE_RIGHT_BUTTON_UP;
		
	if(mouse_state.rgbButtons[2] & 0x80 && !(mouse_state_prev.rgbButtons[2] & 0x80))
		raw->data.mouse.usButtonFlags |= RI_MOUSE_MIDDLE_BUTTON_DOWN;
	
	if(!(mouse_state.rgbButtons[2] & 0x80) && mouse_state_prev.rgbButtons[2] & 0x80)
		raw->data.mouse.usButtonFlags |= RI_MOUSE_MIDDLE_BUTTON_UP;
		
	if(mouse_state.rgbButtons[3] & 0x80 && !(mouse_state_prev.rgbButtons[3] & 0x80))
		raw->data.mouse.usButtonFlags |= RI_MOUSE_BUTTON_4_DOWN;
	
	if(!(mouse_state.rgbButtons[3] & 0x80) && mouse_state_prev.rgbButtons[3] & 0x80)
		raw->data.mouse.usButtonFlags |= RI_MOUSE_BUTTON_4_UP;
	
	if(mouse_state.rgbButtons[4] & 0x80 && !(mouse_state_prev.rgbButtons[4] & 0x80))
		raw->data.mouse.usButtonFlags |= RI_MOUSE_BUTTON_5_DOWN;
	
	if(!(mouse_state.rgbButtons[4] & 0x80) && mouse_state_prev.rgbButtons[4] & 0x80)
		raw->data.mouse.usButtonFlags |= RI_MOUSE_BUTTON_5_UP;
		
	memcpy(&mouse_state_prev, &mouse_state, sizeof(DIMOUSESTATE2));

#ifdef DEBUG_RAW_INPUT
	fwrite("GRF\n", 1, 4, debug_file);
#endif
		
	return sizeof(RAWINPUT);
}

DWORD WINAPI PollInput(HWND hWnd) {
	for(;;) {
		Sleep(1000/60);
		SendMessage(hWnd, WM_INPUT, RIM_INPUT, MOUSE_INPUT);
	}
	return 0;
}

BOOL WINAPI XP_RegisterRawInputDevices(PCRAWINPUTDEVICE pRawInputDevices, UINT uiNumDevices, UINT cbSize) {
	DWORD flags;
	HWND hWnd;
	
#ifdef DEBUG_RAW_INPUT	
	if(!debug_file) debug_file = fopen("user32_log.txt",  "w");
	fwrite("RRS\n", 1, 4, debug_file);	
#endif
	
	if(mouse_init) return FALSE;
	
	//Only support mouse
	if(uiNumDevices != 1) return FALSE;
	if(pRawInputDevices->usUsagePage != 0x01 || pRawInputDevices->usUsage != 0x02) return FALSE;
	
	//Get the window handle if we need to
	hWnd = pRawInputDevices->hwndTarget;
	if(!hWnd) hWnd = GetActiveWindow();
	if(!hWnd) return FALSE;
	
	//Try to map these flags to DirectX
	flags = 0;
	if(pRawInputDevices->dwFlags & RIDEV_INPUTSINK) flags |= DISCL_BACKGROUND;
	else                                            flags |= DISCL_FOREGROUND;
	flags |= DISCL_NONEXCLUSIVE;
	
	//Init mouse
	if (FAILED(DirectInput8Create(GetModuleHandle(NULL), DIRECTINPUT_VERSION, &IID_IDirectInput8, (void**)&lpdi, NULL)))
		return FALSE;
	
	if (FAILED(lpdi->lpVtbl->CreateDevice(lpdi, &GUID_SysMouse, &m_mouse, NULL)))
		return FALSE;
		
	if (FAILED(m_mouse->lpVtbl->SetCooperativeLevel(m_mouse, hWnd, flags)))
		return FALSE;
		
	if (FAILED(m_mouse->lpVtbl->SetDataFormat(m_mouse, &c_dfDIMouse2)))
		return FALSE;

	m_mouse->lpVtbl->Acquire(m_mouse); //OK if we don't acquire now
	
	if(!CreateThread(NULL, 0, PollInput, hWnd, 0, NULL))
		return FALSE;
		
#ifdef DEBUG_RAW_INPUT
	fwrite("RRF\n", 1, 4, debug_file);
#endif
			
	mouse_init = TRUE;
		
	return TRUE;
}

